import java.awt.Color;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Panel;
import java.awt.Scrollbar;
import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;

public class UE20Aufgabe13 {

	final static int DEF_ROT = 0;
	final static int DEF_GRUEN = 0;
	final static int DEF_BLAU = 0;
	final static int REGLER_GROESSE = 1;
	final static int RGB_MIN = 0;
	final static int RGB_MAX = 255 + REGLER_GROESSE;
	

	private Panel farbPanel;

	public static void main(String[] args) {
		new UE20Aufgabe13();
	}

	public UE20Aufgabe13() {
		Frame frame = new Frame("Scrollbars");
		frame.setLayout(new GridLayout(0, 1));

		this.farbPanel = new Panel();
		this.farbPanel.setBackground(new Color(UE20Aufgabe13.DEF_ROT,
				UE20Aufgabe13.DEF_GRUEN, UE20Aufgabe13.DEF_BLAU));
		frame.add(this.farbPanel);

		Panel scrollbarsPanel = new Panel();
		scrollbarsPanel.setLayout(new GridLayout(1, 0));

		Scrollbar rot = new Scrollbar(Scrollbar.HORIZONTAL, UE20Aufgabe13.DEF_ROT,
				UE20Aufgabe13.REGLER_GROESSE, UE20Aufgabe13.RGB_MIN,
				UE20Aufgabe13.RGB_MAX);
		
		rot.setBackground(Color.RED);
		scrollbarsPanel.add(rot);

		Scrollbar gruen = new Scrollbar(Scrollbar.HORIZONTAL,
				UE20Aufgabe13.DEF_GRUEN, UE20Aufgabe13.REGLER_GROESSE,
				UE20Aufgabe13.RGB_MIN, UE20Aufgabe13.RGB_MAX);
		gruen.setBackground(Color.GREEN);
		scrollbarsPanel.add(gruen);

		Scrollbar blau = new Scrollbar(Scrollbar.HORIZONTAL,
				UE20Aufgabe13.DEF_BLAU, UE20Aufgabe13.REGLER_GROESSE,
				UE20Aufgabe13.RGB_MIN, UE20Aufgabe13.RGB_MAX);
		blau.setBackground(Color.BLUE);
		scrollbarsPanel.add(blau);

		ScrollListener scroll = new ScrollListener(farbPanel, rot, gruen, blau);
		rot.addAdjustmentListener(scroll);
		gruen.addAdjustmentListener(scroll);
		blau.addAdjustmentListener(scroll);

		frame.add(scrollbarsPanel);

		frame.setBounds(10, 10, 800, 600);
		frame.setVisible(true);
	}

}

class ScrollListener implements AdjustmentListener {
	private Panel farbPanel;
	private Scrollbar rot, gruen, blau;

	public ScrollListener(Panel p, Scrollbar r, Scrollbar g, Scrollbar b) {
		this.farbPanel = p;
		this.rot = r;
		this.gruen = g;
		this.blau = b;
	}

	public void adjustmentValueChanged(AdjustmentEvent e) {
		this.farbPanel.setBackground(new Color(rot.getValue(),
				gruen.getValue(), blau.getValue()));
	}
}
