import java.awt.Button;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;

public class UE20Aufgabe30 {

	public static void main(String[] args) {
		char[] brett = { '.', '1', '.', '.', '1', '.', '1', '2', '.', '1' };
		GameFrame frame = new GameFrame(brett);
		frame.setBounds(10, 10, 800, 600);
		frame.setVisible(true);
	}

}

class GameFrame extends JFrame {

	Button[] fields;
	Label messagesLabel;
	int currentPlayer;

	GameFrame(char[] brett) {
		super("Silver-Dollar-Game");
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.currentPlayer = 1;
		this.setLayout(new GridLayout(2, 1));
		Panel buttonPanel = new Panel();
		buttonPanel.setLayout(new GridLayout(1, 0));
		this.add(buttonPanel);
		this.fields = new Button[brett.length];
		for (int i = 0; i < brett.length; i++) {
			this.fields[i] = new Button("" + brett[i]);
			this.fields[i].addActionListener(new FieldListener(this, i));
			buttonPanel.add(this.fields[i]);
		}
		this.messagesLabel = new Label("Spieler " + this.currentPlayer
				+ " beginnt");
		this.add(this.messagesLabel);
	}

	void changePlayer() {
		this.currentPlayer = this.currentPlayer == 1 ? 2 : 1;
		this.messagesLabel.setText("Spieler " + this.currentPlayer
				+ " ist am Zug!");
	}

	void invalidMove() {
		this.messagesLabel.setText("Ungueltiger Spielzug! Spieler "
				+ this.currentPlayer + " hat verloren!");
		this.finish();
	}

	boolean checkEnd() {
		for (int i = 0; i < this.fields.length; i++) {
			if (this.fields[i].getLabel().equals("2")) {
				return false;
			}
		}
		this.messagesLabel.setText("Glueckwunsch! Spieler "
				+ this.currentPlayer + " hat gewonnen!");
		this.finish();
		return true;
	}

	void finish() {
		for (Button field : this.fields) {
			field.setEnabled(false);
		}
	}

	Button[] getFields() {
		return this.fields;
	}

	Label getMessagesLabel() {
		return this.messagesLabel;
	}
}

class FieldListener implements ActionListener {

	GameFrame frame;
	int number;

	static boolean isRMove = false; // Flag zum Anzeigen eines R-Spielzuges
	static int fromField = -1; // von-Feld bei R-Spielzug

	FieldListener(GameFrame frame, int number) {
		this.frame = frame;
		this.number = number;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		// zweiter Klick bei einem R-Spielzug
		if (FieldListener.isRMove) {
			if (this.number >= FieldListener.fromField) {
				this.frame.invalidMove();
				return;
			}
			for (int i = FieldListener.fromField - 1; i >= this.number; i--) {
				if (!this.frame.getFields()[i].getLabel().equals(".")) {
					this.frame.invalidMove();
					return;
				}
			}
			this.frame.getFields()[this.number]
					.setLabel(this.frame.getFields()[FieldListener.fromField]
							.getLabel());
			this.frame.getFields()[FieldListener.fromField].setLabel(".");
			FieldListener.isRMove = false;
			if (!this.frame.checkEnd()) {
				this.frame.changePlayer();
			}
			return;
		}
		// auf leeres Feld ueberpruefen
		if (this.frame.getFields()[this.number].getLabel().equals(".")) {
			this.frame.invalidMove();
			return;
		}

		// auf R-Spielzug ueberpruefen
		for (int i = this.number - 1; i >= 0; i--) {
			if (!this.frame.getFields()[i].getLabel().equals(".")) {
				// R-Spielzug
				FieldListener.isRMove = true;
				FieldListener.fromField = this.number;
				return;
			}
		}

		// S-Spielzug
		this.frame.getFields()[this.number].setLabel(".");
		if (!this.frame.checkEnd()) {
			this.frame.changePlayer();
		}
	}

}
