
public class UE20Aufgabe33 {

	// Konstanten sollen prinzipiell geaendert werden koennen, ohne den Code
	// aendern zu muessen!
	final static int ANZAHL_MUENZEN = 12;
	final static int ANZAHL_SPIELER = 3;
	final static int MIN_MUENZWERT = 1;
	final static int MAX_MUENZWERT = 6;

	public static void main(String[] args) {
		// speichert die Reihe von Muenzen
		DoubleSideStackI muenzen = initMuenzen();
		// speichert die Punkte pro Spieler
		int[] spieler = initSpieler();
		// aktueller Spieler (Index zum spieler-Array)
		int aktuellerSpielerIndex = 0;
		printMuenzenUndStand(muenzen, spieler);
		while (true) {
			printAktuellerSpieler(aktuellerSpielerIndex);
			spielzug(muenzen, spieler, aktuellerSpielerIndex);
			printMuenzenUndStand(muenzen, spieler);
			if (spielEnde(muenzen)) {
				siegerBekanntgeben(spieler);
				break;
			}
			aktuellerSpielerIndex = naechsterSpieler(aktuellerSpielerIndex);
		}
	}

	// initialisiert die Spieler; anfangs haben alle 0 Punkte
	static int[] initSpieler() {
		return new int[ANZAHL_SPIELER];
	}

	// initialisiert die Muenzen (per Zufall)
	static DoubleSideStackI initMuenzen() {
		DoubleSideStackI muenzen = new DoubleSideStack();
		for (int i = 0; i < ANZAHL_MUENZEN; i++) {
			muenzen.pushRight(getRandomNumber(MIN_MUENZWERT, MAX_MUENZWERT));
		}
		return muenzen;
	}

	// - gibt die Muenzen aus
	// - gibt die Punktestaende der einzelnen Spieler aus
	static void printMuenzenUndStand(DoubleSideStackI muenzen, int[] spieler) {
		System.out.println("Muenzen: " + muenzen.toString());
		for (int i = 0; i < spieler.length; i++) {
			System.out.println("Spieler " + i + ": " + spieler[i]);
		}
	}

	// gibt aus, welcher Spieler als naechstes an der Reihe ist
	static void printAktuellerSpieler(int index) {
		System.out.println("Spieler " + index + " ist am Zug!");
	}

	// gefordert
	// - fragt nach Seite (rechts oder links)
	// - entfernt Muenze von entsprechender Seite
	// - addiert Wert der entfernten Muenze zum Punktestand des aktuellen
	// Spielers
	static void spielzug(DoubleSideStackI muenzen, int[] spieler,
			int aktuellerSpielerIndex) {
		char seite = IO
				.readChar("Muenze von welcher Seite nehmen (r oder l)? ");
		if (seite == 'l') {
			int muenze = muenzen.popLeft();
			spieler[aktuellerSpielerIndex] += muenze;
		} else {
			int muenze = muenzen.popRight();
			spieler[aktuellerSpielerIndex] += muenze;
		}
	}

	// gefordert
	// ermittelt den oder die Gewinner und gibt die Gewinner bekannt
	static void siegerBekanntgeben(int[] spieler) {
		int max = 0;
		for (int i = 0; i < spieler.length; i++) {
			if (spieler[i] > max) {
				max = spieler[i];
			}
		}
		for (int i = 0; i < spieler.length; i++) {
			if (spieler[i] == max) {
				System.out.println("Spieler " + i + " ist Gewinner");
			}
		}
	}

	// ueberprueft das Spielende
	static boolean spielEnde(DoubleSideStackI muenzen) {
		return muenzen.isEmpty();
	}

	// gefordert
	// liefert den Spieler, der als naechstes an der Reihe ist; gespielt wird
	// reihum
	static int naechsterSpieler(int aktuellerSpielerIndex) {
		return (aktuellerSpielerIndex + 1) % ANZAHL_SPIELER;
	}

	// liefert Zufallszahl zwischen min und max
	static int getRandomNumber(int min, int max) {
		return (int) (min + ((Math.random() * (max - min)) + 1));
	}

}

