
// gegeben
class Mensch {
	private int alter;

	public Mensch(int alter) {
		this.alter = alter;
	}

	public int getAlter() {
		return alter;
	}

	public void setAlter(int alter) {
		this.alter = alter;
	}
}

// gegeben
interface Bedingung {
	boolean istErfuellt(Mensch mensch);
}

// gesucht
class Volljaehrig implements Bedingung {

	@Override
	public boolean istErfuellt(Mensch mensch) {
		return mensch.getAlter() >= 18;
	}
}

// gesucht
class MenschArrayList extends java.util.ArrayList<Mensch> {

	public MenschArrayList filtern(Bedingung bedingung) {
		MenschArrayList neueListe = new MenschArrayList();
		for (Mensch mensch : this) {
			if (bedingung.istErfuellt(mensch)) {
				neueListe.add(mensch);
			}
		}
		return neueListe;
	}

}

// gesucht
public class UE20Aufgabe38 {

	public static void main(String[] args) {
		// MenschArrayList erzeugen
		MenschArrayList menschen = new MenschArrayList();
		
		// Menschen generieren und in ArrayList eintragen
		for (int i=0; i<10; i++) {
			int zufallsAlter = (int)(Math.random() * 80) + 1;
			menschen.add(new Mensch(zufallsAlter));
		}
		
		// Volljaehrige ausfiltern
		MenschArrayList volljaehrige = menschen.filtern(new Volljaehrig());
		
		// Volljaehrige ausgeben
		for (Mensch mensch : volljaehrige) {
			System.out.println(mensch.getAlter());
		}
	}
}



