import java.awt.Button;
import java.awt.Color;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;

class Spieler {
	int reihe;
	int spalte;
	String name;

	public Spieler(int reihe, int spalte, String name) {
		super();
		this.reihe = reihe;
		this.spalte = spalte;
		this.name = name;
	}

	public int getReihe() {
		return reihe;
	}

	public void setReihe(int reihe) {
		this.reihe = reihe;
	}

	public int getSpalte() {
		return spalte;
	}

	public void setSpalte(int spalte) {
		this.spalte = spalte;
	}

	public String getName() {
		return name;
	}

}

public class UE20Aufgabe40 {

	public final static int ANZAHL_REIHEN = 8;
	public final static int ANZAHL_SPALTEN = 6;

	private boolean[][] brett;
	private Spieler[] spieler;
	private Spieler aktuellerSpieler;
	private Button[][] buttons;
	private int spielPhase;
	private Label nachrichtenLabel;

	public static void main(String[] args) {
		new UE20Aufgabe40();
	}

	public UE20Aufgabe40() {
		brett = new boolean[ANZAHL_REIHEN][ANZAHL_SPALTEN];
		for (int r = 0; r < brett.length; r++) {
			for (int s = 0; s < brett[r].length; s++) {
				brett[r][s] = true;
			}
		}
		brett[0][ANZAHL_SPALTEN / 2 - 1] = false;
		brett[ANZAHL_REIHEN - 1][ANZAHL_SPALTEN / 2] = false;

		spieler = new Spieler[2];
		spieler[0] = new Spieler(0, ANZAHL_SPALTEN / 2 - 1, "Rot");
		spieler[1] = new Spieler(ANZAHL_REIHEN - 1, ANZAHL_SPALTEN / 2, "Blau");
		aktuellerSpieler = spieler[0];

		spielPhase = 0;

		JFrame fenster = new JFrame("Isola");
		fenster.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		fenster.setLayout(new GridLayout(2, 1));

		Panel buttonPanel = new Panel();
		buttonPanel.setLayout(new GridLayout(ANZAHL_REIHEN, ANZAHL_SPALTEN));

		buttons = new Button[ANZAHL_REIHEN][ANZAHL_SPALTEN];
		for (int r = 0; r < buttons.length; r++) {
			for (int s = 0; s < buttons[r].length; s++) {
				buttons[r][s] = new Button(" ");
				buttons[r][s].addActionListener(new ClickListener(this, r, s));
				buttonPanel.add(buttons[r][s]);
			}
		}
		setzeButtonFarbe();
		enableAnklickbareButtons();

		fenster.add(buttonPanel);

		nachrichtenLabel = new Label(
				"Spieler " + aktuellerSpieler.getName() + ": Figur auf grünes Nachbarfeld ziehen (klicken)");
		fenster.add(nachrichtenLabel);

		fenster.pack();
		fenster.setVisible(true);
	}

	public void enableAnklickbareButtons() {
		if (spielPhase == 0) {
			for (int r = 0; r < buttons.length; r++) {
				for (int s = 0; s < buttons[r].length; s++) {
					buttons[r][s].setEnabled(false);
				}
			}
			int reihe = aktuellerSpieler.getReihe();
			int spalte = aktuellerSpieler.getSpalte();
			for (int r = reihe - 1; r <= reihe + 1; r++) {
				if (r >= 0 && r < ANZAHL_REIHEN) {
					for (int s = spalte - 1; s <= spalte + 1; s++) {
						if (s >= 0 && s < ANZAHL_SPALTEN) {
							if (brett[r][s] && !(spieler[0].getReihe() == r && spieler[0].getSpalte() == s)
									&& !(spieler[1].getReihe() == r && spieler[1].getSpalte() == s)) {
								buttons[r][s].setEnabled(true);
							}
						}
					}
				}
			}
		} else {
			for (int r = 0; r < buttons.length; r++) {
				for (int s = 0; s < buttons[r].length; s++) {
					if (brett[r][s] && !(spieler[0].getReihe() == r && spieler[0].getSpalte() == s)
							&& !(spieler[1].getReihe() == r && spieler[1].getSpalte() == s)) {
						buttons[r][s].setEnabled(true);
					} else {
						buttons[r][s].setEnabled(false);
					}
				}
			}
		}
	}

	public void setzeButtonFarbe() {
		for (int r = 0; r < buttons.length; r++) {
			for (int s = 0; s < buttons[r].length; s++) {
				if (spieler[0].getReihe() == r && spieler[0].getSpalte() == s) {
					buttons[r][s].setBackground(Color.RED);
				} else if (spieler[1].getReihe() == r && spieler[1].getSpalte() == s) {
					buttons[r][s].setBackground(Color.BLUE);
				} else if (brett[r][s]) {
					buttons[r][s].setBackground(Color.GREEN);
				} else {
					buttons[r][s].setBackground(Color.WHITE);
				}
			}
		}
	}

	public Spieler getAktuellerSpieler() {
		return aktuellerSpieler;
	}

	public void setAktuellerSpieler(Spieler aktuellerSpieler) {
		this.aktuellerSpieler = aktuellerSpieler;
	}

	public boolean[][] getBrett() {
		return brett;
	}

	public Spieler[] getSpieler() {
		return spieler;
	}

	public Button[][] getButtons() {
		return buttons;
	}

	public int getSpielPhase() {
		return spielPhase;
	}

	public void setSpielPhase(int spielPhase) {
		this.spielPhase = spielPhase;
		if (spielPhase == 0) {
			nachrichtenLabel.setText(
					"Spieler " + aktuellerSpieler.getName() + ": Figur auf grünes Nachbarfeld ziehen (klicken)");
		} else {
			nachrichtenLabel.setText("Spieler " + aktuellerSpieler.getName() + ": Grünes Feld demaskieren (klicken)");
		}
	}

	public void spielerWechsel() {
		if (aktuellerSpieler == spieler[0]) {
			aktuellerSpieler = spieler[1];
		} else {
			aktuellerSpieler = spieler[0];
		}
	}

	public void ueberpruefeEnde() {
		if (spielPhase == 0) {
			boolean ende = true;
			int reihe = aktuellerSpieler.getReihe();
			int spalte = aktuellerSpieler.getSpalte();
			schleife: for (int r = reihe - 1; r <= reihe + 1; r++) {
				if (r >= 0 && r < ANZAHL_REIHEN) {
					for (int s = spalte - 1; s <= spalte + 1; s++) {
						if (s >= 0 && s < ANZAHL_SPALTEN) {
							if (brett[r][s] && !(spieler[0].getReihe() == r && spieler[0].getSpalte() == s)
									&& !(spieler[1].getReihe() == r && spieler[1].getSpalte() == s)) {
								ende = false;
								break schleife;
							}
						}
					}
				}
			}
			if (ende) {
				nachrichtenLabel.setText("Spieler " + aktuellerSpieler.getName() + " hat verloren!");
				for (int r = 0; r < buttons.length; r++) {
					for (int s = 0; s < buttons[r].length; s++) {
						buttons[r][s].setEnabled(false);
					}
				}
			}
		}
	}

}

class ClickListener implements ActionListener {

	private UE20Aufgabe40 spiel;
	private int reihe;
	private int spalte;

	public ClickListener(UE20Aufgabe40 spiel, int reihe, int spalte) {
		this.spiel = spiel;
		this.reihe = reihe;
		this.spalte = spalte;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (spiel.getSpielPhase() == 0) {
			spiel.getAktuellerSpieler().setReihe(reihe);
			spiel.getAktuellerSpieler().setSpalte(spalte);
			spiel.setSpielPhase(1);
		} else {
			spiel.getBrett()[reihe][spalte] = false;
			spiel.spielerWechsel();
			spiel.setSpielPhase(0);
		}
		spiel.enableAnklickbareButtons();
		spiel.setzeButtonFarbe();
		spiel.ueberpruefeEnde();
	}

}
