// https://de.wikipedia.org/wiki/Decorator#Ein_Beispiel_in_C.23

/*
 * 15 Punkte
 */
interface Spielfigur {
	void drohe();
}

class Monster implements Spielfigur {

	@Override
	public void drohe() {
		System.out.println("Grrr!");
	}
}

abstract class Dekorierer implements Spielfigur {
	private Spielfigur figur;

	public Dekorierer(Spielfigur f) {
		this.figur = f;
	}

	@Override
	public void drohe() {
		this.figur.drohe();
	}
}

class Husten extends Dekorierer {

	public Husten(Spielfigur s) {
		super(s);
	}

	@Override
	public void drohe() {
		System.out.print("Hust! ");
		super.drohe();
	}
}

class Schnupfen extends Dekorierer {

	public Schnupfen(Spielfigur s) {
		super(s);
	}

	@Override
	public void drohe() {
		System.out.print("Schnifff! ");
		super.drohe();
	}
}

class Heiserkeit extends Dekorierer {

	public Heiserkeit(Spielfigur s) {
		super(s);
	}

	@Override
	public void drohe() {
		System.out.print("Röchel! ");
		super.drohe();
	}
}

public class UE20Aufgabe42 {

	public static void main(String[] args) {
		Spielfigur meinMonster = new Monster();
		meinMonster.drohe();

		Spielfigur meinVerhustetesMonster = new Husten(meinMonster);
		meinVerhustetesMonster.drohe();

		Spielfigur meinVerschnupftesMonster = new Schnupfen(meinMonster);
		meinVerschnupftesMonster.drohe();

		Spielfigur meinVerschnupftesVerhustetesMonster = new Schnupfen(new Husten(meinMonster));
		meinVerschnupftesVerhustetesMonster.drohe();

		Spielfigur meinVerhustetesVerschnupftesMonster = new Husten(new Schnupfen(meinMonster));
		meinVerhustetesVerschnupftesMonster.drohe();

		Spielfigur meinHeiseresVerschnupftesMonster = new Heiserkeit(new Schnupfen(meinMonster));
		meinHeiseresVerschnupftesMonster.drohe();
	}

}
