class Vignere {

	// enthaelt nur Kleinbuchstaben!
	private String schluesselwort;

	// speichert das Vignere-Quadrat
	private char[][] quadrat = null;

	// schluessel darf nur Kleinbuchstaben enthalten!
	public Vignere(String schluessel) {
		this.schluesselwort = schluessel;
		// initialisieren des Vignere-Quadrates
		this.quadrat = new char[26][26];
		for (int i = 0; i < 26; i++) {
			for (int j = 0; j < 26; j++) {
				this.quadrat[i][j] = (char) ('a' + (i + j) % 26);
			}
		}
	}

	// liefert zu einem uebergebenen Klartext unter Nutzung des im Attribut
	// schluesselwort gespeicherten Schluesselwortes den entsprechenden
	// Geheimtext
	public String verschluesseln(String botschaft) {
		String geheimtext = "";
		for (int i = 0; i < botschaft.length(); i++) {
			char klartextZeichen = botschaft.charAt(i);
			if (klartextZeichen < 'a' || klartextZeichen > 'z') {
				geheimtext = geheimtext + klartextZeichen;
			} else {
				char schluesselZeichen = this.schluesselwort.charAt(i
						% this.schluesselwort.length());
				char geheimtextZeichen = this.quadrat[schluesselZeichen - 'a'][klartextZeichen - 'a'];
				geheimtext = geheimtext + geheimtextZeichen;
			}
		}
		return geheimtext;
	}

	// liefert zu einem uebergebenen Geheimtext unter Nutzung des im Attribut
	// schluesselwort gespeicherten Schluesselwortes den entsprechenden Klartext
	public String entschluesseln(String geheimtext) {
		String klartext = "";
		for (int i = 0; i < geheimtext.length(); i++) {
			char geheimTextZeichen = geheimtext.charAt(i);
			if (geheimTextZeichen < 'a' || geheimTextZeichen > 'z') {
				klartext = klartext + geheimTextZeichen;
			} else {
				char schluesselZeichen = this.schluesselwort.charAt(i
						% this.schluesselwort.length());
				int reihe = schluesselZeichen - 'a';
				int spalte = (geheimTextZeichen + 26 - this.quadrat[reihe][0]) % 26;
				char klartextZeichen = (char) ('a' + spalte);
				klartext = klartext + klartextZeichen;
			}
		}
		return klartext;
	}
}

public class UE20Aufgabe5 {

	// Testprogramm: war nicht gefordert
	public static void main(String[] args) {
		String schluessel = "licht";
		Vignere schluesselObjekt = new Vignere(schluessel);
		String botschaft = "truppenabzugnachosten";
		String geheimtext = schluesselObjekt.verschluesseln(botschaft);
		String entschluesselt = schluesselObjekt.entschluesseln(geheimtext);
		System.out.println(schluessel);
		System.out.println(botschaft);
		System.out.println(geheimtext);
		System.out.println(entschluesselt);
	}
}
